import Vue from 'vue'
import App from '@/App'
import VueModal from 'vue-js-modal'
import store from '@/store'

Vue.use(VueModal)

Vue.config.productionTip = false
Vue.config.silent = true
Vue.config.devTools = false

openerp.eiru_purchases = (instance, local) => {

    local.PurchasesWidget = instance.Widget.extend({
        start() {
            this.sidebarFold()

            this.vm = new Vue({
                store,
                el: this.el,
                template: '<App />',
                components: {
                    App
                }
            })
        },
        destroy() {
            this.vm.$destroy()
            $(this.vm.$el).remove()
            this.vm = null

            this.sidebarUnfold()
            
            this._super.apply(this, arguments)
        },
        sidebarFold() {
            if (!instance.eiru_sidebar_toggler) return
            instance.eiru_sidebar_toggler.sidebar_fold()
        },
        sidebarUnfold() {
            instance.eiru_sidebar_toggler.sidebar_unfold()
        }
    })

    instance.web.client_actions.add('eiru_purchases.action_launch', 'instance.eiru_purchases.PurchasesWidget')
}