import Vue from 'vue'
import Vuex from 'vuex'

import state from '@/store/state'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import actions from '@/store/actions'

import user from '@/store/modules/user'
import currency from '@/store/modules/currency'
import journal from '@/store/modules/journal'
import supplier from '@/store/modules/supplier'
import product from '@/store/modules/product'
import picking from '@/store/modules/picking'
import payment from '@/store/modules/payment'

Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        user,
        currency,
        journal,
        supplier,
        product,
        picking,
        payment
    }
})

export default store