const state = {
    supplier: {
        default: [],
        values: this.default
    },
    filteredSuppliers: {
        default: [],
        values: this.default
    },
    selectedSupplier: {
        default: null,
        value: this.default
    },
    addSupplier: {
        default: false,
        value: this.default
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    suppliers(state) {
        return state.supplier.values
    },
    /**
     * 
     * @param {*} state 
     */
    hasSelectedSupplier(state) {
        return !!state.selectedSupplier.value
    },
    /**
     * 
     * @param {*} state 
     */
    selectedSupplier(state) {
        return state.selectedSupplier.value
    },
    /**
     * 
     * @param {*} state 
     */
    addSupplier(state) {
        return state.addSupplier.value
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setSuppliers(state, payload) {
        state.supplier.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    selectSupplier(state, payload) {
        state.selectedSupplier.value = payload
    },
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    filterSuppliers(state, payload) {
        state.filteredSuppliers.values = [...payload]
    },
    /**
     * 
     * @param {*} state 
     */
    addSupplier(state) {
        state.addSupplier.value = !state.addSupplier.value
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     */
    setSuppliers({ commit }, payload) {
        commit('setSuppliers', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    selectSupplier({ commit }, payload) {
        commit('selectSupplier', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    filterSuppliers({ commit }, payload) {
        commit('filterSuppliers', payload)
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    addSupplier({ commit }) {
        commit('addSupplier')
    },
    /**
     * 
     * @param {*} param0 
     */
    pushSupplier({ commit, dispatch }) {
        console.log('push')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}